%%
%% Link functors
%%

functor

import
   Error(printException)
   Property(get)
   Remote(manager)
   XOS(path)
   
export
   makeApplet: Link
   
define
   
   `/` = [XOS.path.sep]

   OZL_Url = {Property.get 'oz.home'}#`/`#"bin"#`/`#"ozl"
   
   proc {Link InURL Spec OutFile}
      
      Compress = {Int.toString {CondSelect Spec compress 9}}
      Mode     = case {CondSelect Spec exec false}
                 of true then "-x"
                 [] false then "-c"
                 end
      Args     = {Append {CondSelect Spec args nil}
                  ["-z" Compress Mode InURL "-o" OutFile]}
      
      F = functor
          import
             Module(link)
             Property(put get)
          define
             {Property.put 'ozd.args' Args}
             [OZL] = {Module.link [OZL_Url]} in
             {Wait OZL}
          end
      
      R = {New Remote.manager init}
      thread {R apply(F)} end
      %%
      proc {PingLoop}
         {R ping()}
         {Delay 1000}
         {PingLoop}
      end
   in
      try {PingLoop} 
      catch system(dp(...)...) then skip end
   end
end
