%%
%% Message Display
%%

functor

import
   Type(ask)

export
   mkDesc:  MkDesc
   'class': MessageDisplay
   
define
   
   local
      DefaultBG = lightgrey   
   in
      fun {MkDesc}
         H
         Desc = text(glue:nwse handle:H bg:DefaultBG
                     tdscrollbar:true init:"" state:disabled)
      in
         H#Desc
      end
   end
   
   class MessageDisplay
      attr
         handle:    unit
         text:      unit % Dictionary of VS
         defaultID: 0
         currentID: 0
         
      meth init(Handle DefaultID<=0)
         handle    <- Handle
         text      <- {NewDictionary}
         defaultID <- DefaultID
         currentID <- DefaultID
         {Dictionary.put @text DefaultID ""}
      end
      %%
      meth exists(ID $)
         {Dictionary.member @text ID}
      end
      meth create(ID Text<="")
         {Dictionary.put @text ID Text}
      end
      meth remove(ID)
         {Dictionary.remove @text ID}
      end
      %%
      meth Get(ID $)    {Dictionary.get @text ID}      end
      meth Set(ID Text) {Dictionary.put @text ID Text} end
      %%
      %% message printing
      %%
      meth Append(ID Text)
         Old = {Dictionary.get @text ID} in
         {Dictionary.put @text ID Old#Text}
      end
      meth Print(Text)
         {@handle set(state:normal)}
         {@handle insert('end' Text)}
         {@handle set(state:disabled)}
      end 
      meth append(ID Text)
         if ID==@currentID then
            {self Print(Text)}
         end
         {self Append(ID Text)}
      end
      meth printInfo(Text)
         {self append(@currentID Text)}
      end
      %%
      %% display switch
      %%
      meth Load
         Text = {Dictionary.get @text @currentID} in
         {@handle set(state:normal)}
         {@handle set(Text)}
         {@handle set(state:disabled)}
      end
      meth Save 
         Text = {@handle get($)} in
         {Dictionary.put @text @currentID Text}
      end
      meth select(ID)
         if ID\=@currentID then
            {self Save}
            if {Dictionary.member @text ID}==false then
               {self create(ID)}
            end
            currentID <- ID
            {self Load}
         end
      end
   end
end









