%%
%% Progress Display
%%

functor

import
   Type(ask)

   %%QTk at 'http://www.info.ucl.ac.be/people/ned/qtk/QTk.ozf'

export
   mkDesc:  MkDesc
   'class': ProgressDisplay
   
define

   local
      BG=[background highlightbackground selectedbackground disabledbackground]
      FG=[foreground highlightforeground selectedforeground disabledforeground]
      REL=[relief     highlightrelief     selectedrelief     disabledrelief]
      BW=[borderwidth highlightborderwidth selectedborderwidth
          disabledborderwidth]
      %%
      proc {SetAll Obj Features Val}
         {ForAll Features
          proc {$ F} {Obj set(F:Val)} end}
      end
   in
      Set = set(bg:     proc {$ TBButton Col} {SetAll TBButton BG Col} end
                fg:     proc {$ TBButton Col} {SetAll TBButton FG Col} end
                relief: proc {$ TBButton Rel} {SetAll TBButton REL Rel} end
                bw:     proc {$ TBButton Bw}  {SetAll TBButton BW  Bw} end
               )
      %%
      DefaultColors = colors(default: lightgrey
                             active:  yellow
                             success: green
                             error:   red)
      %%
      proc {MkDesc Texts Colors ?Handle#?Desc}
         Col = {Adjoin DefaultColors Colors} in
         {Type.ask.tuple Texts}
         {Record.forAll Texts Type.ask.virtualString}
         Handle = {Record.clone Texts}
         {Adjoin
          {Record.mapInd Texts
           fun {$ N Txt}
              tbbutton(glue:we handle:Handle.N bg:Col.default text:Txt)
           end}
          td ?Desc}
      end
      %%
      class ProgressDisplay
         attr
            handle:  unit
            colors:  unit
            current: 0
            
         meth init(Handle colors:Colors<=unit)
            handle <- Handle
            colors <- {Adjoin DefaultColors Colors}
            {self disableAll}
            {self setAll(relief flat/*ridge*/)}
            {self setAll(bg @colors.default)}
         end
         %%
         meth enable(N)
            {@handle.N set(state:normal)}
         end
         meth disable(N)
            {@handle.N set(state:disabled)}
         end
         meth disableAll
            {Record.forAll @handle
             proc {$ H} {H set(state:disabled)} end}
         end
         %%
         meth set(N Attrib Val)
            {Set.Attrib @handle.N Val}
         end
         meth setAll(Attrib Val)
            {Record.forAll @handle
             proc {$ H} {Set.Attrib H Val} end}
         end
         %%
         meth exists(N $)
            {HasFeature @handle N}
         end
         meth send(N M)
            {@handle.N M}
         end
         %%
         meth SetBG(N Col)
            {Set.bg @handle.N @colors.Col}
         end
         meth current($)
            @current
         end
         meth enter(N<=@current+1)
            {self SetBG(N active)}
            current <- N
         end
         meth leave(N<=@current)
            current <- 0
            {self SetBG(N success)}
         end
         meth next
            Current = @current in
            {self leave(Current)}
            {self enter(Current+1)}
         end
         meth error(N<=@current)
            current <- 0
            {self SetBG(N error)}
         end
      end
   end
end









