%%
%% Mozart Installer
%%

functor

import
   Application(getArgs exit)
   Property(get)
   System(showError showInfo)
   
   Install
   Applet
   
define
   AppName = 'installer'

   %%
   %% args
   %%
   Args
   local
      Spec = record(title(single char:&t type:string default:unit)
                    resolve(single char:&r type:string default:"")
                    cache(single type:atom('local' 'global') default:'local')
                    global(single char:&g alias:cache#'global')
                    compress(single char:&z type:int(min:0 max:9) default:0)
                    applet(single type:string optional:true)
                    output(single char:&o alias:applet)
                    %%link(single char:&l type:bool default:false)
                   )
   in
      try
         Args = {Application.getArgs Spec}
      catch error(ap(usage S)...) then
         {System.showError AppName#": "#S}
         {Application.exit 1}
      end
   end

   %%
   %% main
   %%
   Title     = Args.title
   URLs      = Args.1
   ResolveVS = Args.resolve
   Cache     = Args.cache
   Compress  = Args.compress
   
   if {HasFeature Args applet} then
      %%
      AppletFile = Args.applet
      %%
      URL = {Property.get 'application.url'}
      %%
      ArgsLists =
      [
       if Title     \= unit then ["--title"   Title]     else nil end
       if ResolveVS \= nil  then ["--resolve" ResolveVS] else nil end
       if Cache == 'global' then ["--global"]            else nil end 
       URLs
      ]
      %%
      ARGS = {FoldR ArgsLists Append nil}      
   in
      {Applet.make URL ARGS AppletFile}
   else
      Package = package(title:    Title
                        urls:     URLs
                        resolve:  ResolveVS
                        cache:    Cache
                        compress: Compress)
   in
      {Install.functors Package}
   end
   {Application.exit 0}
end
